/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.records;


import com.tabajara.base.tables.Funcionario;
import com.tabajara.base.tables.interfaces.IFuncionario;

import io.github.jklingsporn.vertx.jooq.shared.internal.VertxPojo;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record5;
import org.jooq.Row5;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class FuncionarioRecord extends UpdatableRecordImpl<FuncionarioRecord> implements VertxPojo, Record5<String, String, String, String, String>, IFuncionario {

    private static final long serialVersionUID = -958106513;

    /**
     * Setter for <code>public.funcionario.funmatricula</code>.
     */
    @Override
    public FuncionarioRecord setFunmatricula(String value) {
        set(0, value);
        return this;
    }

    /**
     * Getter for <code>public.funcionario.funmatricula</code>.
     */
    @Override
    public String getFunmatricula() {
        return (String) get(0);
    }

    /**
     * Setter for <code>public.funcionario.funnome</code>.
     */
    @Override
    public FuncionarioRecord setFunnome(String value) {
        set(1, value);
        return this;
    }

    /**
     * Getter for <code>public.funcionario.funnome</code>.
     */
    @Override
    public String getFunnome() {
        return (String) get(1);
    }

    /**
     * Setter for <code>public.funcionario.funcpf</code>.
     */
    @Override
    public FuncionarioRecord setFuncpf(String value) {
        set(2, value);
        return this;
    }

    /**
     * Getter for <code>public.funcionario.funcpf</code>.
     */
    @Override
    public String getFuncpf() {
        return (String) get(2);
    }

    /**
     * Setter for <code>public.funcionario.funsexo</code>.
     */
    @Override
    public FuncionarioRecord setFunsexo(String value) {
        set(3, value);
        return this;
    }

    /**
     * Getter for <code>public.funcionario.funsexo</code>.
     */
    @Override
    public String getFunsexo() {
        return (String) get(3);
    }

    /**
     * Setter for <code>public.funcionario.funativo</code>.
     */
    @Override
    public FuncionarioRecord setFunativo(String value) {
        set(4, value);
        return this;
    }

    /**
     * Getter for <code>public.funcionario.funativo</code>.
     */
    @Override
    public String getFunativo() {
        return (String) get(4);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Record1<String> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record5 type implementation
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Row5<String, String, String, String, String> fieldsRow() {
        return (Row5) super.fieldsRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Row5<String, String, String, String, String> valuesRow() {
        return (Row5) super.valuesRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field1() {
        return Funcionario.FUNCIONARIO.FUNMATRICULA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field2() {
        return Funcionario.FUNCIONARIO.FUNNOME;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field3() {
        return Funcionario.FUNCIONARIO.FUNCPF;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field4() {
        return Funcionario.FUNCIONARIO.FUNSEXO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field5() {
        return Funcionario.FUNCIONARIO.FUNATIVO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component1() {
        return getFunmatricula();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component2() {
        return getFunnome();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component3() {
        return getFuncpf();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component4() {
        return getFunsexo();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component5() {
        return getFunativo();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value1() {
        return getFunmatricula();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value2() {
        return getFunnome();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value3() {
        return getFuncpf();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value4() {
        return getFunsexo();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value5() {
        return getFunativo();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public FuncionarioRecord value1(String value) {
        setFunmatricula(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public FuncionarioRecord value2(String value) {
        setFunnome(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public FuncionarioRecord value3(String value) {
        setFuncpf(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public FuncionarioRecord value4(String value) {
        setFunsexo(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public FuncionarioRecord value5(String value) {
        setFunativo(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public FuncionarioRecord values(String value1, String value2, String value3, String value4, String value5) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        value5(value5);
        return this;
    }

    // -------------------------------------------------------------------------
    // FROM and INTO
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public void from(IFuncionario from) {
        setFunmatricula(from.getFunmatricula());
        setFunnome(from.getFunnome());
        setFuncpf(from.getFuncpf());
        setFunsexo(from.getFunsexo());
        setFunativo(from.getFunativo());
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public <E extends IFuncionario> E into(E into) {
        into.from(this);
        return into;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached FuncionarioRecord
     */
    public FuncionarioRecord() {
        super(Funcionario.FUNCIONARIO);
    }

    /**
     * Create a detached, initialised FuncionarioRecord
     */
    public FuncionarioRecord(String funmatricula, String funnome, String funcpf, String funsexo, String funativo) {
        super(Funcionario.FUNCIONARIO);

        set(0, funmatricula);
        set(1, funnome);
        set(2, funcpf);
        set(3, funsexo);
        set(4, funativo);
    }

    public FuncionarioRecord(io.vertx.core.json.JsonObject json) {
        this();
        fromJson(json);
    }
}
